"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var io = require("socket.io-client");
var socket = io("https://pay-server.phoenix-project.io");
// var socket=io("http://192.168.0.102:5000")
var _id = "";
socket.on("assign-id", function (data) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("id---->", data.id, "\n message--->", data.message);
                    _id = data.id;
                    return [4 /*yield*/, exports.call(function (token) { })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
});
exports.call = function (callBack) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        console.log("_id is assigned as ---->", _id);
        socket.on("" + _id, function (data) {
            console.log(data);
            if (data.token) {
                console.log("API CALL===>");
                callBack(data);
            }
        });
        return [2 /*return*/];
    });
}); };
var hydro = /** @class */ (function () {
    function hydro(config) {
        var _this = this;
        this.getURL = function () { return __awaiter(_this, void 0, void 0, function () {
            var res, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.urlController()];
                    case 1:
                        res = _a.sent();
                        return [2 /*return*/, JSON.stringify({ url: res.data, socket_id: _id })];
                    case 2:
                        e_1 = _a.sent();
                        // return JSON.stringify(e)
                        console.log(e_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); };
        this.urlController = function () {
            var _a = _this, hydroConfig = _a.hydroConfig, apiURL = _a.apiURL;
            return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                var options, res;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            options = {
                                method: "POST",
                                headers: {
                                    "Content-Type": "application/json;charset=utf-8"
                                },
                                body: JSON.stringify(hydroConfig)
                            };
                            return [4 /*yield*/, fetch(this.apiURL + "/provider/url", options)];
                        case 1:
                            res = _a.sent();
                            return [4 /*yield*/, res.json()];
                        case 2:
                            res = _a.sent();
                            if (res.status !== 200 && res.status !== 201) {
                                reject({ message: res.message });
                            }
                            resolve(res);
                            return [2 /*return*/];
                    }
                });
            }); });
        };
        this.hydroConfig = config;
        // this.apiURL = "http://35.182.74.87:4000";
        this.apiURL = "https://pay-server.phoenix-project.io";
        // this.apiURL = "http://192.168.0.102:5000";
    }
    return hydro;
}());
exports["default"] = hydro;
