import * as io from "socket.io-client";
var socket = io("https://pay-server.phoenix-project.io");
// var socket=io("http://192.168.0.102:5000")
let _id = "";
socket.on("assign-id", async function (data: any) {
  console.log("id---->", data.id, "\n message--->", data.message);
  _id = data.id;
  await call((token: any) => {});
});

export const call = async (callBack: any) => {
  console.log("_id is assigned as ---->", _id);
  socket.on(`${_id}`, (data: any) => {
    console.log(data);
    if (data.token) {
      console.log("API CALL===>");
      callBack(data);
    }
  });
};

export default class hydro {
  hydroConfig: any;
  apiURL: any;
  constructor(config: any) {
    this.hydroConfig = config;
    // this.apiURL = "http://35.182.74.87:4000";
    this.apiURL = "https://pay-server.phoenix-project.io";
    // this.apiURL = "http://192.168.0.102:5000";
  }

  public getURL = async () => {
    try {
      const res: any = await this.urlController();
      return JSON.stringify({ url: res.data, socket_id: _id });
    } catch (e) {
      // return JSON.stringify(e)
      console.log(e);
    }
  };

  urlController = () => {
    const { hydroConfig, apiURL } = this;
    return new Promise(async (resolve, reject) => {
      const options = {
        method: "POST",
        headers: {
          "Content-Type": "application/json;charset=utf-8",
        },
        body: JSON.stringify(hydroConfig),
      };
      let res: any = await fetch(`${this.apiURL}/provider/url`, options);
      res = await res.json();
      if (res.status !== 200 && res.status !== 201) {
        reject({ message: res.message });
      }
      resolve(res);
    });
  };
}
